﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;

namespace MyMemory
{
    public delegate void Job();

    class Handler
    {
        private volatile bool running = false;

        private Thread worker;
        private string name;
        private Job job;

        public Handler(string name, Job job)
        {
            this.name = name;
            this.job = job;
        }

        public void Start()
        {
            running = true;
            worker = new Thread(new ThreadStart(Run));
            worker.Name = name;
            worker.Start();
        }

        public void Stop()
        {
            running = false;
            worker.Join();
        }

        private void Run()
        {
            while (running)
            {
                job();
                Thread.Sleep(1000);
            }
        }
    }
}
