﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.IO;

namespace MyMemory
{
    class Program
    {
        private Dictionary<string, int[]> dict = new Dictionary<string, int[]>();
        private int iKey = 0;
        private int[] iVals = new int[100000];

        Program()
        {
            for (int i = 0; i < 100000; i++)
            {
                iVals[i] = i;
            }
        }

        static void Main(string[] args)
        {
            Program pA = new Program();
            Program pB = new Program();

            Handler ha = new Handler("Handler-A", pA.WorkA);
            Handler hb = new Handler("Handler-B", pB.WorkB);

            ha.Start();
            hb.Start();

            TextReader input;
            input = Console.In;
            string line;
            while ((line = input.ReadLine()) != null)
            {
                Console.WriteLine(line);
                if ("q".Equals(line))
                {
                    Console.WriteLine("Quit");
                    ha.Stop();
                    hb.Stop();
                    break;
                }
                else if ("b".Equals(line)) 
                {
                    Console.WriteLine("Break");
                    Thread.Sleep(1000);
                }
            }
            input.Dispose();
        }

        static void Proc(TextReader tr)
        {
        }

        public void WorkA()
        {
            iKey++;
            dict.Add(iKey.ToString(), (int[])iVals.Clone());
            Console.WriteLine("+ " + Thread.CurrentThread.Name + ": " + iKey + " is added.");
        }

        public void WorkB()
        {
            dict.Remove(iKey.ToString());
            Console.WriteLine("- " + Thread.CurrentThread.Name + ": " + iKey + " is removed.");
            iKey++;
            dict.Add(iKey.ToString(), (int[])iVals.Clone());
            Console.WriteLine("+ " + Thread.CurrentThread.Name + ": " + iKey + " is added.");
        }

    }

}
